#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <time.h>
#include <windows.h>
#include ".\K8055D.h"


double timetic=(double)(CLOCKS_PER_SEC);

char cfg_name[21]="stepcfg2.txt";


double harm_delay(long delay0) {

   long j;
   double sum;


      sum=0.0;

      for (j=1; j<=delay0; j++) {
         sum=sum+1.0/(double)(j);
      } /* for j */

      return(sum);

} /* harm_delay */


int main() {

	FILE *cfgfile;

	int Row, Col;
	int BoardNum = 0;
	int ULStat = 0;
	int PortNum, Direction;
	long DataValue;
	int BitLevel;
	long BitNum;
	long BitValue;
	int hilo;
	char s[32];  // string for user input

	char cc;

	long i, j,k, n,d0,d1,ri,k0,k1,stepsx,stepsy,dirx,diry;
	long cardadr,delay0;

	double sum, sum0,v0,dv,r0,mmx,mmy,sizefac1;
	double x1, y1,x2,y2,dx,dy,x0,y0,ex,ey,rr,x3,y3;
	double x7, y7, aex, aey,dr,dt,c,v1,v2,ss,r,x,y,z,xfac,yfac;

	double pi1 = 3.14159265358979323;


        DataValue = 8;

	cardadr=0;

	OpenDevice(cardadr);



	for (j = 1; j <= 8; j++) {

	   BitNum = j;
	   BitValue = 0;
	   

	   SetDigitalChannel(BitNum);


        } /* for j */

	BitNum = 3;
	BitValue = 1;

	ClearDigitalChannel(BitNum);

	BitNum = 6;
	BitValue = 1;

	ClearDigitalChannel(BitNum);


        if ((cfgfile = fopen(cfg_name, "r")) == NULL) {
		printf("File %s not found.\n", cfg_name);
		exit(0);
	} /* if */

	fscanf(cfgfile,"%ld %lf %ld", &stepsx, &mmx, &dirx);
	fscanf(cfgfile,"%ld %lf %ld", &stepsy, &mmy, &diry);

	if ((dirx != 0) && (dirx != 1)) {
		printf("\n\ndirx not 0 or 1. Program terminated.\n\n");
		exit(0);
	} /* if */

	if ((diry != 0) && (diry != 1)) {
		printf("\n\ndiry not 0 or 1. Program terminated.\n\n");
		exit(0);
	} /* if */


	printf("\nLorenz Attractor\n");
	printf("----------------\n\n");
	printf("Input size factor (float 90.0 mm): ");
	scanf("%lf", &sizefac1);
	printf("Input max integration steps (int 16000): ");
	scanf("%ld", &k0);
	printf("Input dt per line segment (int 8): ");
	scanf("%ld", &k1);
	printf("Input dt (float 0.00125): ");
	scanf("%lf", &dt);
	printf("Input stepper motor delay (int 0 ms): ");
	scanf("%ld", &delay0);
	printf("\n\n");


	printf("Size factor:           %9.3lf mm\n", sizefac1);
	printf("Max integration steps: %6ld\n", k0);
	printf("dt per line segment:   %6ld\n", k1);
	printf("dt:                    %9.6lf\n", dt);
	printf("Stepper motor delay:   %6ld ms\n\n", delay0);
	printf("stepsx mmx dirx:       %6ld %9.3lf %3ld\n", stepsx, mmx, dirx);
	printf("stepsy mmy diry:       %6ld %9.3lf %3ld\n", stepsy, mmy, diry);

	cc = 1;

	printf("\nStart milling or plotting (Y/n return)? ");

	scanf("%s", &cc);

	if (cc != 'Y') {
		printf("\n\nProgram terminated.\n\n");
		exit(0);
	} /* if */

	d0 = 10000;
	sum0 = 0.0;

	v1 = 0.0; v2 = 90.0;

	v1 = cos(v1*pi1 / 180.0);
	v2 = cos(v2*pi1 / 180.0);

	xfac = 0.15*sizefac1*(double)(stepsy)/(mmy*60.0);
	yfac = 0.15*sizefac1*(double)(stepsx)/(mmx*60.0);

	c = -6.0;
	r = 28.0;
	y0 = xfac*0.0;
	x0 = yfac*0.0;
	ss = 8.0 / 3.0;

	x = 1.0; y = 1.0; z = 1.0;

	x1 = x0;
	y1 = y0;

	k = 0;


    while (k < k0) {

		if ((k % 200) == 0) {
			printf("%8ld %12.5f %12.3f\n", k, x1, y1);
		} /* if */

		k++;

		x3 = x;
		y3 = y;

		x = x + 10.0*(y - x)*dt;
		y = y + (-x3*z + r*x3 - y)*dt;
		z = z + (x3*y3 - ss*z)*dt;


		if ((k % k1) == 0) {

		x2 = yfac*c*(x + y*v1) + x0;
		y2 = -1.0*xfac*c*(z + y*v2) + y0;


		dx = x2 - x1;
		dy = y2 - y1;

		rr = sqrt(dx*dx + dy*dy);

		if (rr > 0.0) {
			ex = dx / rr;
			ey = dy / rr;
		}
		else {
			ex = 0.0;
			ey = 0.0;
		} /* if */

		aex = fabs(ex);
		aey = fabs(ey);

		if (dx >= 0.0) {

			BitNum = 2;
			BitValue = dirx;

			if (BitValue == 1) {
				ClearDigitalChannel(BitNum);
			} 
			else {
				SetDigitalChannel(BitNum);
			} /* if */
		}
		else {

                	BitNum = 2;
			BitValue = 1-dirx;

			if (BitValue == 1) {
				ClearDigitalChannel(BitNum);
			} 
			else {
				SetDigitalChannel(BitNum);
			} /* if */


		} /* if */

		if (dy >= 0.0) {

                        BitNum = 5;
			BitValue = diry;

			if (BitValue == 1) {
				ClearDigitalChannel(BitNum);
			} 
			else {
				SetDigitalChannel(BitNum);
			} /* if */

		}
		else {

			BitNum = 5;
			BitValue = 1-diry;

			if (BitValue == 1) {
				ClearDigitalChannel(BitNum);
			} 
			else {
				SetDigitalChannel(BitNum);
			} /* if */


		} /* if */


		ri = (long)(rr);
		x7 = 0.0;
		y7 = 0.0;

		for (i = 1; i < ri; i++) {

			x7 = x7 + aex;
			y7 = y7 + aey;

			if (x7 > 1.0) {

				x7 = x7-1.0;

                                BitNum = 1;
				BitValue = 1;

				ClearDigitalChannel(BitNum);

				/* sum0 = sum0 + harm_delay(delay1 * d0); */

				Sleep(delay0);

				BitNum = 1;
				BitValue = 0;

				SetDigitalChannel(BitNum);

				/* sum0 = sum0 + harm_delay(delay1 * d0); */

				Sleep(delay0);

			} /* if */

			if (y7 > 1.0) {

				y7 = y7-1.0;

	                        BitNum = 4;
				BitValue = 1;

				ClearDigitalChannel(BitNum);

				/* sum0 = sum0 + harm_delay(delay2 * d0); */

				Sleep(delay0);

				BitNum = 4;
				BitValue = 0;

				SetDigitalChannel(BitNum);

				/* sum0 = sum0 + harm_delay(delay2 * d0); */

				Sleep(delay0);

			} /* if */


		} /* for i */

		x1 = x1 + (double)(ri)*ex;
		y1 = y1 + (double)(ri)*ey;

		} /* if */

     } /* while */

 
        BitNum = 3;
	BitValue = 0;

	SetDigitalChannel(BitNum);

	BitNum = 5;
	BitValue = 0;

	SetDigitalChannel(BitNum);

	for (j = 1; j <= 8; j++) {

		BitNum = j;
		BitValue = 0;

	        SetDigitalChannel(BitNum);

	} /* for j */

        printf("\n%12.5lf\n",sum0);

	fclose(cfgfile);


    } /* End program */






